# Return list of groups

GET https://api.letsdeel.com/rest/v2/groups

List all the groups in your organization.
 **Token scopes**: `groups:read`

Reference: https://developer.deel.com/api/endpoints/groups/get-groups

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /groups:
    get:
      operationId: get-groups
      summary: Return list of groups
      description: |-
        List all the groups in your organization.
         **Token scopes**: `groups:read`
      tags:
        - subpackage_groups
      parameters:
        - name: limit
          in: query
          description: The maximum number of groups to return (between 1 and 100)
          required: false
          schema:
            type: integer
            default: 100
        - name: sort_order
          in: query
          description: >-
            Sort the results in ascending (ASC) or descending (DESC) order based
            on the group name.
          required: false
          schema:
            $ref: '#/components/schemas/GroupsGetParametersSortOrder'
        - name: cursor
          in: query
          description: >-
            The encoded cursor for paginated results. This is an opaque string
            that allows fetching the next set of results.
          required: false
          schema:
            type: string
        - name: include_archived_groups
          in: query
          description: Include archived groups (soft deleted records). Defaults to `true`.
          required: false
          schema:
            type: boolean
            default: true
        - name: external_metadata
          in: query
          description: Extra information about the group.
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: A list of groups in the organization.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/groups_getGroups_Response_200'
        '400':
          description: Invalid request parameters.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetGroupsRequestBadRequestError'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    GroupsGetParametersSortOrder:
      type: string
      enum:
        - ASC
        - DESC
      default: ASC
      title: GroupsGetParametersSortOrder
    GroupsGetResponsesContentApplicationJsonSchemaDataItemsStatus:
      type: string
      enum:
        - active
        - archived
      description: The current status of the group (active or archived).
      title: GroupsGetResponsesContentApplicationJsonSchemaDataItemsStatus
    GroupsGetResponsesContentApplicationJsonSchemaDataItemsExternalMetadata:
      type: object
      properties: {}
      description: Extra information about the group.
      title: GroupsGetResponsesContentApplicationJsonSchemaDataItemsExternalMetadata
    GroupsGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          description: The unique identifier of the group.
        name:
          type: string
          description: The name of the group.
        status:
          $ref: >-
            #/components/schemas/GroupsGetResponsesContentApplicationJsonSchemaDataItemsStatus
          description: The current status of the group (active or archived).
        managers:
          type: number
          format: double
          description: The number of managers associated with the group.
        created_at:
          type: string
          format: date-time
          description: The timestamp when the group was created.
        updated_at:
          type: string
          format: date-time
          description: The timestamp when the group was last updated.
        archived_at:
          type:
            - string
            - 'null'
          format: date-time
          description: The timestamp when the group was archived (if applicable).
        external_metadata:
          $ref: >-
            #/components/schemas/GroupsGetResponsesContentApplicationJsonSchemaDataItemsExternalMetadata
          description: Extra information about the group.
      title: GroupsGetResponsesContentApplicationJsonSchemaDataItems
    GroupsGetResponsesContentApplicationJsonSchemaPage:
      type: object
      properties:
        cursor:
          type: string
          description: An opaque cursor to fetch the next set of results.
        total_rows:
          type: integer
          description: >-
            The total number of groups available for the current query
            (including pagination).
      title: GroupsGetResponsesContentApplicationJsonSchemaPage
    groups_getGroups_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/GroupsGetResponsesContentApplicationJsonSchemaDataItems
        page:
          $ref: >-
            #/components/schemas/GroupsGetResponsesContentApplicationJsonSchemaPage
      title: groups_getGroups_Response_200
    GetGroupsRequestBadRequestError:
      type: object
      properties:
        message:
          type: string
          description: Error message explaining what went wrong.
      title: GetGroupsRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/groups"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/groups';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/groups"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/groups")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/groups")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/groups', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/groups");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/groups")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```